Index: s390-tools-sles11/ziomon/ziomon_util.c
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_util.c
+++ s390-tools-sles11/ziomon/ziomon_util.c
@@ -1105,7 +1177,7 @@ static void send_message(int msg_q, void
 
 static int has_ioerrs(struct ioerr_data *ioerr)
 {
-	int i = 0;
+	int i;
 
 	for (i = 0; i < ioerr->num_luns; ++i) {
 		if (ioerr->ioerrors[i].num_ioerr != 0)
@@ -1116,33 +1188,33 @@ static int has_ioerrs(struct ioerr_data 
 }
 
 
-static int has_non_null_stats(struct stat_variance *var)
+static int has_non_null_stats(struct abbrev_stat *var)
 {
 	return !(var->max == 0 && var->min == 0);
 }
 
 
-static int has_adapter_traffic(struct overall_result *res)
+static int has_adapter_traffic(struct utilization_data *res)
 {
-	int i=0;
-	struct adapter_result *a_res;
+	int i;
+	struct adapter_utilization *a_res;
 
 	for (i=0; i<res->num_adapters; ++i) {
-		a_res = &res->results[i];
+		a_res = &res->adapt_utils[i];
 		if (!a_res->valid)
 			return 1;
-		if (a_res->result.queue_full != 0)
+		if (a_res->stats.queue_full != 0)
 			return 1;
-		/* this makes sure that we don't send messages when essentially
-		   no data is processed - reading the 'utilization' attribute
-		   causes always traffic, hence we would always send a message
-		   without this threshold! */
-		if (a_res->result.queue_util_integral
-			/ (double)a_res->result.queue_util_interval >= 0.05)
+		/* makes sure that we don't send messages when essentially no
+		   data is processed. Reading the 'utilization' sysfs attribute
+		   causes traffic, hence we would always send a message without
+		   this threshold! */
+		if (a_res->stats.queue_util_integral
+			/ (double)a_res->stats.queue_util_interval >= 0.05)
 			return 1;
-		if (has_non_null_stats(&a_res->result.adapter)
-		    || has_non_null_stats(&a_res->result.bus)
-		    || has_non_null_stats(&a_res->result.cpu))
+		if (has_non_null_stats(&a_res->stats.adapter)
+		    || has_non_null_stats(&a_res->stats.bus)
+		    || has_non_null_stats(&a_res->stats.cpu))
 			return 1;
 	}
 
@@ -1163,22 +1235,19 @@ static void print_to_msg_q(struct overal
 			print_utilization_result(&res_wrp->o_res);
 		verbose_msg("write utilization result to msg q %d (msg-type: %ld, msg-size: %d)\n",
 				opts->msg_q, res_wrp->mtype, (unsigned int)msg_size);
-	
+
 		conv_overall_result_to_BE(&res_wrp->o_res);
-	
+
 		send_message(opts->msg_q, res_wrp, msg_size);
 	}
 
-
 	if (has_ioerrs(&ioerr->data) || force) {
 		msg_size = get_ioerr_data_sz(&ioerr->data);
 		if (verbose)
 			print_ioerr_data(&ioerr->data);
 		verbose_msg("write ioerr result to msg q %d (msg-type: %ld, msg-size: %d)\n",
 				opts->msg_q, ioerr->mtype, (unsigned int)msg_size);
-	
 		conv_ioerr_data_to_BE(&ioerr->data);
-	
 		send_message(opts->msg_q, ioerr, msg_size);
 	}
 }
@@ -1278,10 +1347,7 @@ int main(int argc, char **argv)
 		do {
 			sample_end.tv_sec += opts.s_duration;
 			sleep_until(&sample_end);
-			if (poll_utilization(all_adapters, &opts)) {
-				rc = -2;
-				goto out;
-			}
+			poll_utilization(all_adapters, &opts);
 			if (timercmp(&sample_end, &interval_end, >=)) {
 				/* final sample in interval */
 				if (poll_queue_full(0, all_adapters, &opts)) {
Index: s390-tools-sles11/ziomon/ziomon_util.h
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_util.h
+++ s390-tools-sles11/ziomon/ziomon_util.h
@@ -16,40 +16,51 @@
 #include "ziomon_tools.h"
 
 
-struct util_result {
+struct utilization_stats {
 	__u64			count;
-	struct stat_variance 	adapter;
-	struct stat_variance 	bus;
-	struct stat_variance 	cpu;
+	struct abbrev_stat 	adapter; /* adapter utilization in percent */
+	struct abbrev_stat 	bus;     /* bus utilization in percent */
+	struct abbrev_stat 	cpu;     /* cpu utilization in percent */
 	__u64			queue_util_integral; /* integral of the queue
 					utilization over microseconds */
 	__u64			queue_util_interval; /* interval length
 							in microseconds */
 	__u32			queue_full;	/* number of queue_full
-	      instances within the given timeframe */
+				   instances within the given timeframe */
 } __attribute__ ((packed));
 
-struct adapter_result {
-	struct util_result	result;
-	__u32			adapter_no;	/* device identifier */
-	__u16			valid;	/* ==0 in case the result is invalid */
+struct adapter_utilization {
+	struct utilization_stats	stats;
+	__u32				adapter_no;	/* device identifier */
+	__u16				valid;	/* ==0 in case the result is invalid */
 } __attribute__ ((packed));
 
-/* Note that this message will always be transmitted in first and final
+/** Note that this message will always be transmitted in first and final
  * interval. Inbetween, only messages with actual traffic will be transmitted.
  */
-struct overall_result {
-	__u64			timestamp;
-	__u16			num_adapters;
-	struct adapter_result	results[0];
+struct utilization_data {
+	__u64				timestamp;
+	__u16				num_adapters;
+	struct adapter_utilization	adapt_utils[0];
 } __attribute__ ((packed));
 
-struct ioerr_cnt {
+struct hctl_ident {
 	__u32			host;	/* device identifier (1) */
 	__u32			channel;/* device identifier (2) */
 	__u32			target;	/* device identifier (3) */
 	__u32			lun;	/* device identifier (4) */
-	__u32			num_ioerr;	
+} __attribute__ ((packed));
+
+/**
+ * Returns <0 if src is 'smaller' than tgt, >0 of 'larger' and 0 if identical.
+ */
+int compare_hctl_idents(const struct hctl_ident *src,
+			const struct hctl_ident *tgt);
+
+struct ioerr_cnt {
+	struct hctl_ident	identifier;
+	__u32			num_ioerr; /* number of io errors
+						within timeframe */
 } __attribute__ ((packed));
 
 /* Note that this message will always be transmitted in first and final
@@ -63,14 +74,21 @@ struct ioerr_data {
 } __attribute__ ((packed));
 
 
-void print_utilization_result(struct overall_result *res);
+void print_utilization_result(struct utilization_data *res);
+
+void conv_overall_result_to_BE(struct utilization_data *res);
 
-void conv_overall_result_to_BE(struct overall_result *res);
+void conv_overall_result_from_BE(struct utilization_data *res);
 
-void conv_overall_result_from_BE(struct overall_result *res);
+/**
+ * Aggregate a complete utilization result with all included structures */
+void aggregate_utilization_data(const struct utilization_data *src,
+				struct utilization_data *tgt);
 
-void aggregate_utilization_data(struct overall_result *src,
-				struct overall_result *tgt);
+/**
+ * Aggregate a result for a single adapter only */
+void aggregate_adapter_result(const struct adapter_utilization *src,
+			      struct adapter_utilization *tgt);
 
 void print_ioerr_data(struct ioerr_data *data);
 
@@ -80,9 +98,14 @@ void conv_ioerr_data_from_BE(struct ioer
 
 /**
  * src must be later data than target! We assume that both structs have
- * data for the same LUNs in the same sequence. 
+ * data for the same LUNs in the same sequence.
  */
-void aggregate_ioerr_data(struct ioerr_data *src, struct ioerr_data *tgt);
+void aggregate_ioerr_data(const struct ioerr_data *src, struct ioerr_data *tgt);
+
+/**
+ * Aggregate data for a single device only */
+void aggregate_ioerr_cnt(const struct ioerr_cnt *src, struct ioerr_cnt *tgt);
+
 
 #endif
 
Index: s390-tools-sles11/ziomon/ziomon_zfcpdd.c
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_zfcpdd.c
+++ s390-tools-sles11/ziomon/ziomon_zfcpdd.c
@@ -26,21 +26,25 @@
 #include "blktrace.h"
 #include "ziomon_zfcpdd.h"
 #include "zt_common.h"
+#include "blkiomon.h"
 
 
 #ifdef WITH_MAIN
+const char *toolname = "ziomon_zfcpdd";
 int verbose=0;
 #endif
 
-static void swap_dstat(struct zfcpdd_dstat *stat) {
+
+static void swap_dstat(struct zfcpdd_dstat *stat)
+{
 	int i;
 
 	swap_64(stat->time);
 	swap_64(stat->count);
 	swap_32(stat->device);
-	swap_stat_variance(&stat->chan_lat);
-	swap_stat_variance(&stat->fabr_lat);
-	swap_stat_variance(&stat->inb);
+	swap_abbrev_stat(&stat->chan_lat);
+	swap_abbrev_stat(&stat->fabr_lat);
+	swap_abbrev_stat(&stat->inb);
 	swap_16(stat->outb_max);
 	for (i=0; i<BLKIOMON_CHAN_LAT_BUCKETS; ++i)
 		swap_32(stat->chan_lat_hist[i]);
@@ -48,11 +52,13 @@ static void swap_dstat(struct zfcpdd_dst
 		swap_32(stat->fabr_lat_hist[i]);
 }
 
-void conv_dstat_to_BE(struct zfcpdd_dstat *stat) {
+void conv_dstat_to_BE(struct zfcpdd_dstat *stat)
+{
 	swap_dstat(stat);
 }
 
-void conv_dstat_from_BE(struct zfcpdd_dstat *stat) {
+void conv_dstat_from_BE(struct zfcpdd_dstat *stat)
+{
 	swap_dstat(stat);
 }
 
@@ -61,6 +67,8 @@ void aggregate_dstat(struct zfcpdd_dstat
 {
 	int i;
 
+	if (src->device != tgt->device)
+		tgt->device = 0xffffffff;
 	if (src->time > tgt->time)
 		tgt->time = src->time;
 	tgt->count += src->count;
@@ -68,9 +76,9 @@ void aggregate_dstat(struct zfcpdd_dstat
 		tgt->chan_lat_hist[i] += src->chan_lat_hist[i];
 	for (i=0; i<BLKIOMON_FABR_LAT_BUCKETS; ++i)
 		tgt->fabr_lat_hist[i] += src->fabr_lat_hist[i];
-	aggregate_stat_variance(&src->chan_lat, &tgt->chan_lat);
-	aggregate_stat_variance(&src->fabr_lat, &tgt->fabr_lat);
-	aggregate_stat_variance(&src->inb, &tgt->inb);
+	aggregate_abbrev_stat(&src->chan_lat, &tgt->chan_lat);
+	aggregate_abbrev_stat(&src->fabr_lat, &tgt->fabr_lat);
+	aggregate_abbrev_stat(&src->inb, &tgt->inb);
 	if (src->outb_max > tgt->outb_max)
 		tgt->outb_max = src->outb_max;
 }
@@ -78,25 +86,28 @@ void aggregate_dstat(struct zfcpdd_dstat
 void zfcpdd_print_stats(struct zfcpdd_dstat *stat)
 {
 	int i;
+	time_t t = stat->time;
 
-	printf("timestamp     : %s", ctime((time_t*)&stat->time));
-	printf("device        : %u\n", stat->device);
-	printf("count         : %lu\n", stat->count);
-	printf("\tchannel latency:\n");
-	print_stat_variance(&stat->chan_lat, stat->count);
+	printf("timestamp     : %s", ctime(&t));
+	printf("device        : %d:%d\n", MAJOR(stat->device),
+					MINOR(stat->device));
+	printf("count         : %lu\n", (long unsigned int)stat->count);
+	printf("\tchannel latency (in nsecs):\n");
+	print_abbrev_stat(&stat->chan_lat, stat->count);
 	printf("\t\tbuckets:");
 	for (i=0; i<BLKIOMON_CHAN_LAT_BUCKETS; ++i)
 		printf(" %u", stat->chan_lat_hist[i]);
-	printf("\n\tfabric latency:\n");
-	print_stat_variance(&stat->fabr_lat, stat->count);
+	printf("\n\tfabric latency (in usecs):\n");
+	print_abbrev_stat(&stat->fabr_lat, stat->count);
 	printf("\t\tbuckets:");
 	for (i=0; i<BLKIOMON_FABR_LAT_BUCKETS; ++i)
 		printf(" %u", stat->fabr_lat_hist[i]);
-	printf("\n\tinbound latency:\n");
-	print_stat_variance(&stat->inb, stat->count);
-	printf("\toutbound q max   : %hu\n", stat->outb_max);
+	printf("\n\tinbound queue fill size:\n");
+	print_abbrev_stat(&stat->inb, stat->count);
+        printf("\toutbound q max   : %hu\n", stat->outb_max);
 }
 
+
 #ifdef WITH_MAIN
 struct output {
 	char *fn;
@@ -105,6 +116,12 @@ struct output {
 	int pipe;
 };
 
+struct hist_log2 {
+	int first;
+	int delta;
+	int num;
+};
+
 static struct hist_log2 clat = {
 	.first = 0,
 	.delta = 1000,
@@ -170,9 +187,9 @@ static struct dstat *zfcpdd_dstat_alloc(
 	else
 		dstat = malloc(sizeof(*dstat));
 	memset(dstat, 0, sizeof(*dstat));
-	init_stat_variance(&dstat->msg.stat.chan_lat);
-	init_stat_variance(&dstat->msg.stat.fabr_lat);
-	init_stat_variance(&dstat->msg.stat.inb);
+	init_abbrev_stat(&dstat->msg.stat.chan_lat);
+	init_abbrev_stat(&dstat->msg.stat.fabr_lat);
+	init_abbrev_stat(&dstat->msg.stat.inb);
 
 	return dstat;
 }
@@ -212,7 +229,7 @@ static int hist_index(__u64 val, struct 
 	return i;
 }
 
-static void zfcpdd_account_hist_log2(__u32 *bucket, __u32 val,
+static void zfcpdd_account_hist_log2(__u32 *bucket, __u64 val,
 					struct hist_log2 *h)
 {
 	int index = hist_index(val, h);
@@ -222,6 +239,7 @@ static void zfcpdd_account_hist_log2(__u
 static void zfcpdd_account_outb(struct zfcpdd_dstat *stat,
 					struct zfcp_blk_drv_data *dd)
 {
+	/* incoming data reports number of _free_ slots! */
 	dd->outb_usage = 128 - dd->outb_usage;
 	if (dd->outb_usage > stat->outb_max)
 		stat->outb_max = dd->outb_usage;
@@ -232,14 +250,14 @@ static int zfcpdd_account(struct blk_io_
 {
 	struct dstat *dstat;
 	struct zfcpdd_dstat *stat;
-	
+
 	pthread_mutex_lock(&dstat_mutex);
-	
+
 	dstat = zfcpdd_dstat_find(&dstat_hash[dstat_curr], bit);
 	if (!dstat) {
 		dstat = zfcpdd_dstat_alloc();
 		if (!dstat) {
-			perror("ziomon_zfcpdd: could not alloc statistic");
+			fprintf(stderr, "%s: could not alloc statistic: %s\n", toolname, strerror(errno));
 			pthread_mutex_unlock(&dstat_mutex);
 			return 1;
 		}
@@ -251,9 +269,9 @@ static int zfcpdd_account(struct blk_io_
 		dstat->msg.stat.device, dstat_curr, &dstat_hash[dstat_curr], dstat);
 
 	stat = &dstat->msg.stat;
-	update_stat_variance(&stat->chan_lat, dd->chan_lat);
-	update_stat_variance(&stat->fabr_lat, dd->fabr_lat / 1000);
-	update_stat_variance(&stat->inb, dd->inb_usage);
+	update_abbrev_stat(&stat->chan_lat, dd->chan_lat);
+	update_abbrev_stat(&stat->fabr_lat, dd->fabr_lat / 1000);
+	update_abbrev_stat(&stat->inb, dd->inb_usage);
 	zfcpdd_account_outb(stat, dd);
 	zfcpdd_account_hist_log2(stat->chan_lat_hist, dd->chan_lat,
 				    &clat);
@@ -267,11 +285,11 @@ static int zfcpdd_account(struct blk_io_
 
 static void dump_bit(struct blk_io_trace *bit, const char *descr)
 {
-	fprintf(stderr, "--- %s ---\n", descr);
+	fprintf(stderr, "--- %s: %s ---\n", toolname, descr);
 	fprintf(stderr, "magic    %16d\n", bit->magic);
 	fprintf(stderr, "sequence %16d\n", bit->sequence);
-	fprintf(stderr, "time     %16ld\n", bit->time);
-	fprintf(stderr, "sector   %16ld\n", bit->sector);
+	fprintf(stderr, "time     %16lu\n", (long unsigned int)bit->time);
+	fprintf(stderr, "sector   %16lu\n", (long unsigned int)bit->sector);
 	fprintf(stderr, "bytes    %16d\n", bit->bytes);
 	fprintf(stderr, "action   %16x\n", bit->action);
 	fprintf(stderr, "pid      %16d\n", bit->pid);
@@ -295,7 +313,7 @@ static int zfcpdd_output_binary(struct d
 	return 0;
 
 failed:
-	fprintf(stderr, "ziomon_zfcpdd: could not write to %s\n", binary.fn);
+	fprintf(stderr, "%s: could not write to %s\n", toolname, binary.fn);
 	fclose(binary.fp);
 	binary.fn = NULL;
 	return 1;
@@ -316,20 +334,20 @@ static void print_hist(FILE *fp, const c
 		(unsigned long)(hist_upper_limit(i - 1, h)), a[i]);
 }
 
-static void print_var(FILE *fp, const char *s, struct stat_variance *v)
+static void print_var(FILE *fp, const char *s, struct abbrev_stat *v)
 {
 	fprintf(fp, "%s: min %ld, max %ld, sum %ld, squ %ld\n", s,
 		(unsigned long)v->min, (unsigned long)v->max,
 		(unsigned long)v->sum, (unsigned long)v->sos);
 }
 
-static int zfcpdd_output_ascii(struct dstat *dstat)
+static void zfcpdd_output_ascii(struct dstat *dstat)
 {
 	struct zfcpdd_dstat *p = &dstat->msg.stat;
 	FILE *fp = ascii.fp;
 
 	if (!ascii.fn)
-		return 0;
+		return;
 
 	fprintf(fp, "device: %d\t", p->device);
 	fprintf(fp, "interval end: %ld\n", (unsigned long)p->time);
@@ -342,7 +360,7 @@ static int zfcpdd_output_ascii(struct ds
 		   p->chan_lat_hist, &clat);
 	print_hist(fp, "fabric latency histogram (in usec)",
 		   p->fabr_lat_hist, &flat);
-	return 0;
+	return;
 }
 
 static int zfcpdd_output_msg_q(struct dstat *dstat)
@@ -366,8 +384,7 @@ static int zfcpdd_output(struct dstat *d
 		dstat->msg.stat.device, dstat);
 
 	dstat->msg.stat.time = time(NULL);
-	if (zfcpdd_output_ascii(dstat))
-		return 1;
+	zfcpdd_output_ascii(dstat);
 	if (zfcpdd_output_binary(dstat))
 		return 1;
 	if (zfcpdd_output_msg_q(dstat))
@@ -399,8 +416,6 @@ static void zfcpdd_consume(struct dhash 
 	}
 }
 
-static char zfcpdd_version[] = "0.2";
-
 static pthread_t interval_thread;
 
 
@@ -444,7 +459,7 @@ static int zfcpdd_open_output(struct out
 	return 0;
 
 failed:
-	fprintf(stderr, "ziomon_zfcpdd: could not open %s\n", out->fn);
+	fprintf(stderr, "%s: could not open %s\n", toolname, out->fn);
 	out->fn = NULL;
 	free(out->buf);
 	return 1;
@@ -485,25 +500,26 @@ static int zfcpdd_do_fifo(void)
 	while (fread(&bit, sizeof(bit), 1, ifp) == 1 && main_run) {
 		if (ferror(ifp)) {
 			clearerr(ifp);
-			perror("ziomon_zfcpdd: could not read trace");
-			break;
-		}
-		if (!(bit.action & 0x40000000) ||
-		    bit.pdu_len != sizeof(dd)) {
-			clearerr(ifp);
-			dump_bit(&bit, "ziomon_zfcpdd: not a valid trace");
+			fprintf(stderr, "%s: could not read trace: %s\n", toolname, strerror(errno));
 			break;
 		}
 		if (fread(&dd, bit.pdu_len, 1, ifp) != 1) {
 			clearerr(ifp);
-			perror("ziomon_zfcpdd: could not read trace payload");
+			fprintf(stderr, "%s: could not read trace payload: %s\n", toolname, strerror(errno));
 			break;
 		}
-		if (zfcpdd_account(&bit, &dd))
-			break;
+		if (bit.action & 0x40000000) {
+			if (bit.pdu_len != sizeof(dd)) {
+				clearerr(ifp);
+				dump_bit(&bit, "not a valid trace");
+				break;
+			}
+			if (zfcpdd_account(&bit, &dd))
+				break;
+		}
 	}
 	if (main_run)
-		verbose_msg("pipe ended, exiting");
+		verbose_msg("pipe ended, exiting\n");
 
 	return 0;
 }
@@ -512,15 +528,15 @@ static void *zfcpdd_interval(void *data)
 {
 	struct timespec t;
 	int finished;
-	
+
 	clock_gettime(CLOCK_REALTIME, &t);
-	
+
 	while (run) {
 		t.tv_sec += interval;
 		if (clock_nanosleep(CLOCK_REALTIME, TIMER_ABSTIME, &t, NULL)) {
 			if (!run)
 				break;
-			perror("ziomon_zfcpdd: interrupted sleep");
+			fprintf(stderr, "%s: interrupted sleep:%s\n", toolname, strerror(errno));
 			continue;
 		}
 
@@ -535,10 +551,10 @@ static void *zfcpdd_interval(void *data)
 	return data;
 }
 
-#define S_OPTS "a:b:i:Q:q:m:v:V"
+#define S_OPTS "a:b:i:Q:q:m:Vvh"
 
 static char usage_str[] = "[-v] [-V] [-h] [-b <file>] [-Q <msgq_path> -q <msgq_id>\n"
-	"                       -m <msg_id>] -i <interval>\n"
+	" -m <msg_id>] -i <interval>\n"
 	"\n"
 	"Collect device statistics from blktrace stream.\n"
 	"\n"
@@ -565,9 +581,9 @@ static struct option l_opts[] = {
 	{ NULL,              0,                 NULL,  0  }
 };
 
-static void zfcpdd_usage(char *prog)
+static void zfcpdd_usage(void)
 {
-	fprintf(stdout, "Usage: %s %s", prog, usage_str);
+	fprintf(stdout, "Usage: %s %s", toolname, usage_str);
 }
 
 int main(int argc, char *argv[])
@@ -577,8 +593,8 @@ int main(int argc, char *argv[])
 	register_signals();
 
 	if (argc <= 1) {
-		zfcpdd_usage(argv[0]);
-		return 1;	
+		zfcpdd_usage();
+		return 1;
 	}
 
 	while ((c = getopt_long(argc, argv, S_OPTS, l_opts, NULL)) != -1) {
@@ -605,40 +621,40 @@ int main(int argc, char *argv[])
 			verbose++;
 			break;
 		case 'h':
-			zfcpdd_usage(argv[0]);
+			zfcpdd_usage();
 			return 0;
 		case 'v':
-			printf("ziomon_zfcpdd: ziomon manager %s (%s).\n"
-				"Copyright IBM Corp. 2008.\n",
-				RELEASE_STRING, zfcpdd_version);
+			printf("%s: ziomon fcp monitor version %s\n"
+				"Copyright IBM Corp. 2008\n", toolname,
+				RELEASE_STRING);
 			return 0;
 		default:
-			fprintf(stderr, "Try 'ziomon_zfcpdd --help' for more"
-                                        " information.\n");
+			fprintf(stderr, "Try '%s --help' for more"
+                                        " information.\n", toolname);
 			return 1;
 		}
 	}
 
 	ifp = fdopen(STDIN_FILENO, "r");
 	if (!ifp) {
-		perror("ziomon_zfcpdd: could not open stdin for reading");
+		fprintf(stderr, "%s: could not open stdin for reading: %s\n", toolname, strerror(errno));
 		return 1;
 	}
 
-	if ((msg_q_name && (msg_q_id < 0 || msg_id == LONG_MIN))
-	    || (msg_q_id >= 0 && (!msg_q_name || msg_id == LONG_MIN))
-	    || (msg_id != LONG_MIN && (!msg_q_name || msg_q_id < 0))) {
-		fprintf(stderr, "ziomon_zfcpdd: error: make sure to specify "
-			"all required arguments for message queue.\n");
-		return -1;
+	if (msg_q_name || msg_q_id >= 0 || msg_id != LONG_MIN) {
+		if (!msg_q_name || msg_q_id < 0 || msg_id == LONG_MIN) {
+			fprintf(stderr, "%s: error: make sure to specify "
+				"all required arguments for message queue.\n", toolname);
+			return -1;
+		}
 	}
-	
+
 	if (!interval) {
-		fprintf(stderr, "ziomon_zfcpdd: error: interval required\n");
-		zfcpdd_usage(argv[0]);
+		fprintf(stderr, "%s: error: interval required\n", toolname);
+		zfcpdd_usage();
 		return 1;
 	}
-	
+
 	if (zfcpdd_open_output(&ascii))
 		return 1;
 	if (zfcpdd_open_output(&binary))
@@ -648,7 +664,7 @@ int main(int argc, char *argv[])
 
 	/* setup thread which saves data to disk after the specified interval */
 	if (pthread_create(&interval_thread, NULL, zfcpdd_interval, NULL)) {
-		perror("ziomon_zfcpdd: could not create thread");
+		fprintf(stderr, "%s: could not create thread: %s\n", toolname, strerror(errno));
 		return 1;
 	}
 
@@ -659,12 +675,12 @@ int main(int argc, char *argv[])
 	run = 0; /* thread control variable */
 	pthread_kill(interval_thread, SIGINT);
 	pthread_join(interval_thread, NULL);
-	
+
 	/* aquire mutes before closing the file to avoid data corruption */
 	pthread_mutex_lock(&dstat_mutex);
 	zfcpdd_close_output(&binary);
 	pthread_mutex_unlock(&dstat_mutex);
-	
+
 	return 0;
 }
 #endif
Index: s390-tools-sles11/ziomon/ziomon_zfcpdd.h
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_zfcpdd.h
+++ s390-tools-sles11/ziomon/ziomon_zfcpdd.h
@@ -18,22 +18,22 @@
 
 struct zfcpdd_dstat {
 	__u64 time;
+	/* Channel latency histogram in n-secs.
+	   Step-size is 1000, starting at 0. */
 	__u32 chan_lat_hist[BLKIOMON_CHAN_LAT_BUCKETS];
+	/* fabric latency histogram in u-secs.
+	   Step-size is 8, starting at 0. */
 	__u32 fabr_lat_hist[BLKIOMON_FABR_LAT_BUCKETS];
-	struct stat_variance chan_lat;
-	struct stat_variance fabr_lat;
-	struct stat_variance inb;
-	__u64 count;
+	struct abbrev_stat chan_lat;	/* channel latency in nano-seconds
+					   NOTE: often rescaled to micro-seconds
+						 later on! */
+	struct abbrev_stat fabr_lat;	/* fabric latency in micro-seconds */
+	struct abbrev_stat inb;	/* inbound fill size */
+	__u64 count;	/* number of samples for abbrev_stats */
 	__u32 device;	/* device identifier */
-	__u16 outb_max;
+	__u16 outb_max;	/* max used slots in qdio outbound queue */
 } __attribute__ ((packed));
 
-struct hist_log2 {
-	int first;
-	int delta;
-	int num;
-};
-
 void zfcpdd_print_stats(struct zfcpdd_dstat *stat);
 
 void conv_dstat_to_BE(struct zfcpdd_dstat *stat);
